﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.8
@EndOfDesignText@
'Version: 1
'Author: Alexander Stolte
Private Sub Class_Globals
	
	Private CONST app_id As String = "7038c50061d2e5db54e3bea7faf6a65ffaacd831"
	                                 
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
End Sub

Public Sub GetDeviceUID As String
	
	#IF B4A
	
	Dim runtimep As RuntimePermissions
	runtimep.CheckAndRequest(runtimep.PERMISSION_READ_PHONE_STATE)
	
	Dim uid As String
	Dim phone As Phone
	Dim phoneid As PhoneId
	
	If phoneid.GetLine1Number = "" Then
		
		Dim phone_number_on_sim As String = Null
		
		Else
			
		Dim phone_number_on_sim As String = phoneid.GetLine1Number
			
	End If
	
	Dim hardware_serial As String = GetDeviceId
	Dim android_id As String = phone.GetSettings("android_id")
	Dim device_id As String = phoneid.GetDeviceId
	
	If phoneid.GetSubscriberId = "" Then
		
		Dim subscriber_id As String = Null
		
		Else
			
		Dim subscriber_id As String = phoneid.GetSubscriberId
		
	End If
	
	If phoneid.GetSimSerialNumber = "" Then
		
		Dim sim_serial_number As String = Null
		
		Else
			
		Dim sim_serial_number As String = phoneid.GetSimSerialNumber
			
	End If
	
	uid = SHA256Hash(app_id & phone_number_on_sim & hardware_serial & android_id & device_id & subscriber_id & sim_serial_number)
	
	#Else If B4I
	
	Dim uid As String 
	uid = SHA256Hash(app_id & GetPhoneID)
	
	#End IF
	
	Return uid
	
End Sub

#If B4A

Private Sub GetDeviceId As String
	Dim r As Reflector
	Dim Api As Int
	Api = r.GetStaticField("android.os.Build$VERSION", "SDK_INT")
	If Api < 9 Then
		'Old device
		If File.Exists(File.DirInternal, "__id") Then
			Return File.ReadString(File.DirInternal, "__id")
		Else
			Dim id As Int
			id = Rnd(0x10000000, 0x7FFFFFFF)
			File.WriteString(File.DirInternal, "__id", id)
			Return id
		End If
	Else
		'New device
		Return r.GetStaticField("android.os.Build", "SERIAL")
	End If
End Sub

#End if

#IF B4I

Private Sub GetPhoneID As String
	
	Dim no As NativeObject
	no = no.Initialize("UIDevice").RunMethod("currentDevice", Null)
	Dim id As Object = no.GetField("identifierForVendor").GetField("UUIDString")
	Return id
End Sub

#End If


Private Sub SHA256Hash (text As String) As String
	Dim md As MessageDigest
	Dim ByteCon As ByteConverter
	Dim passwordhash() As Byte
  
	passwordhash = md.GetMessageDigest(text.GetBytes("UTF8"),"SHA-256")
	Dim SHA256string As String
	SHA256string = ByteCon.HexFromBytes(passwordhash)
	SHA256string = SHA256string.ToLowerCase
	Return SHA256string
End Sub

